package de.ivu.elect.presentation.gruppe.table;

import de.ivu.elect.business.gruppe.entity.Gruppe;
import de.ivu.elect.business.wahl.entity.NlWahlPhase;
import de.ivu.elect.jee.presentation.dynamictable.ColumnEntry;

import javax.enterprise.inject.Specializes;
import java.util.ArrayList;
import java.util.List;

@Specializes
public class NlWasGruppeColumnBuilder extends NlGruppeColumnBuilder {

  private static final long serialVersionUID = 1L;
  private AbstractGruppeColumn<Gruppe> gruppeVorgegebenePositionColumn;

  public NlWasGruppeColumnBuilder() {
    super();
  }

  @Override
  protected void initColumns() {
    super.initColumns();

    gruppeVorgegebenePositionColumn = AbstractGruppeColumn.createGruppeVorgegebenePositionColumn(getMessages());
  }

  @Override
  protected List<ColumnEntry<? super Gruppe>> getColumnEntriesSorted() {
    List<ColumnEntry<? super Gruppe>> result = new ArrayList<>();

    if (!isWahlMitReferendengebietenSelected()) {
      result.add(gruppeVorgegebenePositionColumn);//ELECT-11088
      //ELECT-11512
      result.add(gruppeFarbeColumn);
    }

    result.addAll(super.getColumnEntriesSorted());

    if (!isWahlMitReferendengebietenSelected()) {
      result.addAll(getColumnEntriesListenStel());


      // ELECT-10998
      //   result.add(gruppeInPraesentationColumn);
    }

    return result;
  }

}
